package ma.projet.controller;

import java.io.File;
import java.io.IOException;
import java.io.InputStream;
import java.util.List;
import javax.servlet.ServletException;
import javax.servlet.annotation.WebServlet;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import ma.projet.beans.User;
import ma.projet.service.UserImpl;
import org.apache.commons.fileupload.FileItem;
import org.apache.commons.fileupload.disk.DiskFileItemFactory;
import org.apache.commons.fileupload.servlet.ServletFileUpload;

/**
 *
 * @author Lachgar
 */
@WebServlet(urlPatterns = {"/FileUploadHandler"})
public class FileUploadHandler extends HttpServlet {

    String nom;
    String prenom;
    String path;
    private String UPLOAD_DIRECTORY = "/Galerie/web/ressource/image/";

    @Override
    protected void doPost(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {

        UPLOAD_DIRECTORY = getServletContext().getRealPath("/").replace("build\\", "") + "ressource" + File.separator + "images";
        //process only if its multipart content
        if (ServletFileUpload.isMultipartContent(request)) {
            try {
                List<FileItem> multiparts = new ServletFileUpload(
                        new DiskFileItemFactory()).parseRequest(request);
                String name = null;
                for (FileItem item : multiparts) {
                    if (!item.isFormField()) {
                        name = new File(item.getName()).getName();
                        item.write(new File(UPLOAD_DIRECTORY + File.separator + name));
                        path = UPLOAD_DIRECTORY + File.separator + name;
                    } else {
                        InputStream input = item.getInputStream();
                        if (item.getFieldName().equals("Nom")) {
                            byte[] str = new byte[input.available()];
                            input.read(str);
                            nom = new String(str, "UTF8");
                        }
                        if (item.getFieldName().equals("Prenom")) {
                            byte[] str = new byte[input.available()];
                            input.read(str);
                            prenom = new String(str, "UTF8");
                        }
                    }
                }
                //File uploaded successfully

                UserImpl user = new UserImpl();
                user.create(new User(nom, prenom, name));

                request.setAttribute("message", "File Uploaded Successfully le nom est :" + nom + " le prenom est :" + prenom);
            } catch (Exception ex) {
                request.setAttribute("message", "File Upload Failed due to " + ex);
            }
        } else {
            request.setAttribute("message",
                    "Sorry this Servlet only handles file upload request");
        }

        request.getRequestDispatcher("/result.jsp").forward(request, response);
    }

  

}
